<?php
/*
Plugin Name: Bookmark Export
Plugin URI: http://wordpress.org/extend/plugins/bookmark-export/
Description: Bookmark Export helps you push your popularity using social bookmarking services.
Version: 0.1
Author: Timo Schlueter
Author URI: http://wordpress.org/extend/plugins/profile/tmuh
Update Server: http://www.t-muh.de
Min WP Version: 2.7.0
Max WP Version: 2.7.1
*/
 
/*  Copyright 2009  Timo Schlueter  (email : timo.schlueter@me.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function bookmarkexport($type) {

	 /* Set the header of the bookmark-file */
	$head 		= "<!DOCTYPE NETSCAPE-Bookmark-file-1>\n".
				  "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=UTF-8\">\n".
				  "<TITLE>Bookmarks</TITLE>\n".
				  "<H1>Bookmarks</H1>\n".
				  "<DL><p>\n";
	
	global $post;
 	$myposts = get_posts('numberposts=-1');
 	foreach($myposts as $post) {
 	
 		/* Collect the needed parts of the post */
 		$permalink 		= get_permalink($post->ID);
 		$post_date 		= strtotime($post->post_date);
 		$modified_date 	= strtotime($post->post_modified);
 		$posttags 		= get_the_tags($post->ID);
 		$tag_count 		= count($posttags);
 		$count 			= 0;
 		 		 		 		 		
 		foreach($posttags as $tag => $obj) {
 			if($type == "mister-wong")
 			{
 				$tags 		= $tags.$obj->name . ' ';
 			} else {
 		
 				if ($type == "delicious")
 				{
 					$tags 		= $tags.$obj->name . ', ';
 				} else {
 					$tags 		= $tags.$obj->name . ' ';
 				}
 			}
 		} 		
 			
 		$post_title 	= get_the_title($post->ID);
 		
 		/* Create a body-string for every single post */		
 		$body 			= $body."<DT><A HREF=\"$permalink\" ADD_DATE=\"$post_date\" LAST_MODIFIED=\"$modified_date\" TAGS=\"$tags\">$post_title</A>\n<DD>$post->post_excerpt\n(tags: $tags)\n";
 		
 		/* Flush the toile... ehh variables */
 		$permalink 		= null;
 		$post_date 		= null;
 		$modified_date 	= null;
 		$post_title 	= null;
 		$posttags 		= null;
 		$tags 			= null;
 		
 	}
 	
 	/* Set the footer of the bookmark-file */
 	$foot		= "</DL><p>\n";
 	
 	/* Put it all together */
 	$complete 	= $head.$body.$foot;
 	 	
 	/* Initialize the directories */
 	$upload_dir = wp_upload_dir();
 	$upload_dir = $upload_dir["basedir"];
 	
	/* Set the filename */
 	 if($type == "mister-wong")
 	 {
 	 	$filename 	= "$upload_dir/mister-wong-export.html";
 	 }
 	 
 	if($type == "delicious")
 	 {
 	 	$filename 	= "$upload_dir/delicious-export.html";
 	 }
 	
 	/* Check if the file exists */
 	if (file_exists($filename))
 	{
 		/* Check if the file is writeable */
 		if(is_writeable($filename))
 		{
 			/* Write the stuff to the bookmark-file */
 			$handler = fopen($filename, "w+");
 			fwrite($handler, $complete);
 			fclose($handler);
 		} else {
 			/* Do nothing */
 		}
 		
 	} else {
 		/* Do nothing */
 	}
 	
}

function bookmarkexport_is_ready() {
	/* Initialize the directories */
	$upload_dir 	= wp_upload_dir();
 	$upload_dir 	= $upload_dir["basedir"];
 	
 	/* Initialize the export-files */
 	$wong_file 		= "mister-wong-export.html";
 	$delicious_file = "delicious-export.html";

	/* Sanity-checks for mister-wong START */
	if (file_exists("$upload_dir/$wong_file"))
	{
		echo "$wong_file <span style=\"color: green;\">exists </span>";
		if (is_writeable("$upload_dir/$wong_file"))
		{
			echo "and is <span style=\"color: green;\">writable</span>!";
		} else {
			echo "but it's <span style=\"color: red;\">not writable</span>!";
		}
	} else {
		echo "$wong_file <span style=\"color: red;\">does not exist in upload-directory</span>!";
	}
	
	/* Sanity-checks for mister-wong START END */
	echo "<br />";
	
	/* Sanity-checks for delicious START */
	if (file_exists("$upload_dir/$delicious_file"))
	{
		echo "$delicious_file <span style=\"color: green;\">exists </span>";
		if (is_writeable("$upload_dir/$delicious_file"))
		{
			echo "and is <span style=\"color: green;\">writable</span>!";
		} else {
			echo "but it's <span style=\"color: red;\">not writable</span>!";
		}
	} else {
		echo "$delicious_file <span style=\"color: red;\">does not exist in upload-directory</span>!";
	}
	
	/* Sanity-checks for delicious END */
	
		echo "<br />";
	
}


function bookmarkexport_menu() {
  add_options_page('Bookmark Export Options', 'Bookmark Export', 8, __FILE__, 'bookmarkexport_options');
}

function bookmarkexport_options() {  

	/* Initialize the directories */
	$plugin_dir = get_option("siteurl")."/wp-content/plugins/".plugin_basename(dirname(__FILE__));
	$file_dir = wp_upload_dir();
 	$file_dir = $file_dir["baseurl"];
	
	/* Call the export functions for each bookmarking-service */
  	bookmarkexport("mister-wong");
	bookmarkexport("delicious");
	
 	echo '<div class="wrap">';
 	
		/* Informations START */
		echo "<h2>Information</h2>";
		echo "<div style=\"width:800px; text-align:justify; border-color:grey; border-style:dotted; border-width:1px; padding:8px;\">
		Bookmark Export is a plugin that automatically generates bookmark files which you can easily import into your favourite
		social-bookmarking service. 
		It exports every single post you have written and automatically adds the needed information to the bookmark-file.
		For now, it officially supports delicoius and mister-wong bookmarks. There are many more services
		to come.<br />
		If you have any questions about the plugin and its future developement feel free to contact me at timo.schlueter (at) me.com</div>";
		/* Informations END */
		
		/* Prerequirements START */
		echo "<h2>Prerequirements</h2>";
		bookmarkexport_is_ready();
		/* Prerequirements END */
		
		/* Export START */
		echo "<h2>Export</h2>";
		echo "<a href=\"$file_dir/mister-wong-export.html\">Download Mister-Wong Bookmark-File</a> <img src=\"http://static.delicious.com/img/delicious.gif\" alt=\"mister-wong-button\" border=\"0\" />";
		echo "<br />";
		echo "<br />";
		echo "<a href=\"$file_dir/delicious-export.html\">Download del.icio.us Bookmark-File</a> <img src=\"http://www.mister-wong.de/img/buttons/logo16.gif\" alt=\"mister-wong-button\" border=\"0\" />";
		/* Export END */
		
	echo '</div>';
}

/* Add the Adminmenu */
add_action('admin_menu', 'bookmarkexport_menu');
?>
